//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
//                                  BASIC TEST №2 
//                  (compatible with FLProg - visual programming system)
//    1.1.Setting parameters, incl. test pins from controller parameters. Can be changed.
//    1.2.In each loop() loop, the "Task Manager" is executed.
//    1.3.Every second the project performance is calculated.
//    2.1.The console is initialized (after initialization, no time is spent on execution).
//    2.2.After the console is ready, the header with the controller parameters is displayed once,
//        including scanning the i2c bus. If there are no pull-up resistors on the i2c bus to Vcc
//        or i2c devices, possibly hanging due to the CORE feature.
//    3.1.The change in each cycle of the loop is output on the Control pin (for a logic analyzer).
//    3.2.Meander=500ms is output on the Led pin.
//    4.2.Reading from the ADC pin (period 100ms).
//    4.2.Write to the PWM pin values from ADC (period 100ms).
//    4.3.Reading a button with 50ms bounce protection.
//-------------------------------------------------------------------------------------------------
//    To configure the IDE to work with supported boards, instructions to the Readme.hpp.
//-------------------------------------------------------------------------------------------------
// ecoins@mail.ru 07.05.23
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//#include "flprogUtilites.h"   //--Connect SDK FLProg;
#include "RT_HW_BASE.h"         //--Connection of the base library;
//============================Connecting Internal Functions========================================
#include "Asystem.hpp"         //--Objects and variables;;   
//======================================SETUP()====================================================
void setup(){}
//=======================================LOOP()====================================================
void loop(){
//============================3.System functions=================================================== 
initProject();                                  //--Settings;
RT_HW_Base.sheduler();                          //--Sheduler tasks;
if(RT_HW_Base.shed.eventSec){                   //--Call 1 time per second;
vSpeedMCU=RT_HW_Base.shed.cycle;                //--Get speed MCU;
vSpeedMCUF=filterSpeed.filtered(vSpeedMCU);     //--Performance calculation with filtering; 
vSpeedSmall=round(((float)vSpeedMCUF)/1000);}   //--Performance calculation with filtering/1000;
//============================2.INITIALIZING THE CONSOLE AND DISPLAYING HEADERS====================
RT_HW_Base.consoleBegin();                      //--Console initialization;
if(RT_HW_Base.console.head){consoleHead();}     //--Single output to the console of the project header;
//============================3.OUTPUT TO CONTROL PIN AND PIN LED=========== ======================
RT_HW_Base.pinDigitalWrite(idPinControl,pinControl,RT_HW_Base.shed.control);    //--loop() output to control pin;
RT_HW_Base.pinDigitalWrite(idPinLed,    pinLed,    RT_HW_Base.shed.blink500);   //--Meander 500ms to Led; 
//============================4.I/O Pins===========================================================
if(RT_HW_Base.shed.fast.num==1) {fncADC();}     //--Read  ADC; 
if(RT_HW_Base.shed.fast.num==2) {fncPWM();}     //--Write PWM; 
if(RT_HW_Base.shed.frdm.num==3) {fncButton();}  //--Anti-bounce button reading;
//==============================5.PERIODIC CONSOLE OUTPUT==========================================
if(RT_HW_Base.shed.fast.num==3) {
if(cnt++>30)           {cnt=1;}
if(vAgoButton!=vButton){cnt=1;}
if(++cntADC>5){cntADC=0; if(vAgoADC!=vADCF) {cnt=1;}}
if(first==0)  {if(vSpeedMCU>0)     {first=1; cnt=1;}}
if(cnt==1){vAgoButton=vButton; vAgoADC=vADCF; cntADC=0;
           RT_HW_Base.consoleTest(String(F("Button")),(uint8_t)vButton,';');
           RT_HW_Base.consoleTest(String(F(" ADC")),vADCF,';');
           RT_HW_Base.consoleTest(String(F(" Speed")),vSpeedMCUF); 
}}
//-------------------------------------------------------------------------------------------------
}; //++++END loop()================================================================================
   
