//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                                  BASIC TEST №3 
//                  (compatible with FLProg - visual programming system)
//    2.1.The console is initialized (after initialization, no time is spent on execution).
//    2.2.After the console is ready, the header with the controller parameters is displayed once,
//        including scanning the i2c bus. If there are no pull-up resistors on the i2c bus to Vcc
//        or i2c devices, possibly hanging due to the CORE feature.
//    3.1.The change in each cycle of the loop is output on the Control pin (for a logic analyzer).
//    3.2.Meander=500ms is output on the Led pin.
//-------------------------------------------------------------------------------------------------
//    To configure the IDE to work with supported boards, instructions to the Readme.hpp.
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint32_t codeCustomBrd=0;       //--Custom board ID (Raspberry Pi Pico DNS.01);
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//#include "flprogUtilites.h"   //--Connect SDK FLProg;
#include "RT_HW_BASE.h"         //--Connection of the base library;
//=================================OBJECTS AND VARIABLES===========================================
RT_HW_PIN_DIR_ID   idPinControl;    uint8_t pinControl; //--Control;
RT_HW_PIN_DIR_ID   idPinLed;        uint8_t pinLed;     //--Led on Board;
RT_HW_GENERATOR_EVENT_ID idGenLed;                      //--Generator for Led;
RT_HW_GENERATOR_EVENT_ID idGenScan;                     //--Generator for scan i2c;
uint8_t pinSDA,pinSCL;
uint8_t pinSDA1,pinSCL1;
uint8_t vInit=0;                                        //--Parameter initialization flag;
uint8_t bus=0;                                          //--var fo num bus;
//======================================SETUP()====================================================
void setup(){}
//=======================================LOOP()====================================================
void loop(){
//======================================1.Init parameters==========================================
if(vInit==0){vInit=1;
codeCustomBrd=204001; //--Custom board ID (Raspberry Pi Pico DNS.01);
pinControl=RT_HW_Base.device.pin.control; 
pinLed=RT_HW_Base.device.pin.led; 
//=================================================================================================
#if defined(RT_HW_CORE_RP2040)
//-------------------------------------------------------------------------------------------------
//if(codeCustomBrd==204001){RT_HW_Base.i2cSetPins(28,29,0);}   //--pinSDA,pinSCL,bus;
//-------------------------------------------------------------------------------------------------
#endif
//=================================================================================================
}

//======================================2.Heading console output===================================
RT_HW_Base.consoleBegin();        //--Console initialization;
if(RT_HW_Base.console.head==1){   //--Single output to the console of the project header;
  RT_HW_Base.consoleHead(String(F("BASIC TEST №3(scan i2c)")),'=');
  RT_HW_Base.consoleHead(String(F("Main parameters")));     RT_HW_Base.mess.modePin='T';   RT_HW_Base.consoleBoardGeneral();           
  RT_HW_Base.consoleHead(String(F("Interface")));           RT_HW_Base.mess.modePin='T';   RT_HW_Base.consoleInterface(); 
  RT_HW_Base.consoleHead(String(F("System pins")));         RT_HW_Base.mess.modePin='T';   RT_HW_Base.consolePinsSystem();  
  RT_HW_Base.consoleLine('-');
  bus=0;
  if(RT_HW_Base.i2cCheckBus(bus)){RT_HW_Base.consoleTest(String(F("i2c ok bus")),bus);}
  RT_HW_Base.i2cHeadInterface(bus);
  RT_HW_Base.consoleLine('+');
  //bus=1;
  //if(RT_HW_Base.i2cCheckBus(bus)){RT_HW_Base.consoleTest(String(F("i2c ok bus")),bus);}
  //RT_HW_Base.i2cHeadInterface(bus);
  //RT_HW_Base.consoleLine('=');  
  RT_HW_Base.consoleHead(String(F("Scan i2c")));            RT_HW_Base.mess.modePin='T';   RT_HW_Base.i2cScanBus(0);   
  RT_HW_Base.consoleLine('+');
}
//===================================2.Output meander on Led=======================================
RT_HW_Base.sheduler();                          //--Sheduler tasks;
RT_HW_Base.pinDigitalWrite(idPinControl,pinControl,RT_HW_Base.shed.blink250);   //--loop() output to control pin; 
RT_HW_Base.pinDigitalWrite(idPinLed,    pinLed,    RT_HW_Base.shed.blink500);   //--Meander 500ms to Led; 
//--------------------------------------------------------------------------------------------------
//if(RT_HW_Base.generatorEvent(idGenLed,500)){
//   RT_HW_Base.pinDigitalWrite(idPinLed,pinLed,idGenLed.meander);}  //--Meander 500ms on Led; 
//===================================3.Scan i2c====================================================
if(RT_HW_Base.generatorEvent(idGenScan,1000)){
  RT_HW_Base.i2cScanBus(0);
  //RT_HW_Base.i2cScanBus(1);
}
}; //++++END loop()================================================================================
   
