//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						Data structure for working with the device via communication interface
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//=================================================================================================
//						1.Data structure for working with the device via i2c
//=================================================================================================
struct RT_HW_STRUCT_I2C_DEV{
uint8_t  custom=0;				//--1.Setting option;
uint8_t  status=0;				//--2.Status device: =0 no init; =1 Master.MCU->Slave.device; =2 Slave;
uint8_t  link=0;				//--3.Completed transaction flag;
uint8_t  codeErr=0,err=0;		//--4.Code error;
uint8_t  bus=0;					//--5.Number bus;
uint8_t	 adr=255; 				//--6.Аddress;
uint8_t  expander=0,  agoExpander=255;  //--7.1.i2c expander address;
uint8_t  channel=255, agoChannel=255;	//--7.2.i2c expander channel number;	
//-------------------------------------------------------------------------------------------------
uint8_t  stop=1;				//--8.Stop bit;
//-------------------------------------------------------------------------------------------------
uint8_t  bf8;					//--Working register
uint8_t  idx;					//--Working index;
uint8_t  cnt;					//--Working counter;
uint8_t  cntErr;				//--Working counter Error;	
//-------------------------------------------------------------------------------------------------
uint32_t speed=RT_HW_I2C_SPEED;	//--Speed;	
};
//=================================================================================================
//						3.Data structure for working with the deviceс SPI
//=================================================================================================
struct RT_HW_STRUCT_SPI_DEV{
uint8_t  custom=0;				//--1.Setting option;
uint8_t  status=0;				//--2.Status device: =0 no init; =1 Master.MCU->Slave.device; =2 Slave;
uint8_t  link=0;				//--3.Completed transaction flag;
uint8_t  codeErr=0,err=0;		//--4.Code error;
uint8_t  bus=0;					//--5.Number bus;
//-------------------------------------------------------------------------------------------------
uint8_t  cs=255; 				//--6.4.cs Pin number;
uint8_t  bitOrder=1;			//--6.5.In the device, the most significant bit is ahead;
uint8_t  dataMode=0;			//--6.6.In the device dataMode=0;
uint8_t  qnt=1;					//--6.9.Word size in bytes;
//--------------------------------------------------------------------------------------------------
uint32_t bf32;					//--Working register;
//--------------------------------------------------------------------------------------------------
int8_t   idx;
uint8_t  t1=0,t2=0,t3=0;		//--6.1.size delay(mcs) for direct CS;
//-------------------------------------------------------------------------------------------------	
uint32_t speed=RT_HW_SPI_SPEED;	//--Speed bus;	
};
//=================================================================================================
//						4.Data structure for working with the device via SPN
//=================================================================================================	
struct RT_HW_STRUCT_SPN_DEV{
//-------------------------------------------------------------------------------------------------
uint8_t  custom=0;				//--1.Setting option;
uint8_t  status=0;				//--2.Status device: =0 no init; =1 Master.MCU->Slave.device; =2 Slave;
uint8_t  link=0;				//--3.Completed transaction flag;
uint8_t  codeErr=0,err=0;		//--4.Code error;
//-------------------------------------------------------------------------------------------------
uint8_t  sck=255;				//--6.1.sck  Pin number;
uint8_t  miso=255;				//--6.2.miso Pin number;
uint8_t  mosi=255;				//--6.3.mosi Pin number;
uint8_t  cs=255;				//--6.4.cs Pin number;
uint8_t  bitOrder=1;			//--6.6.In var, the most significant bit is ahead; 
uint8_t  qnt=1;					//--6.9.Word size in bytes;
//-------------------------------------------------------------------------------------------------
uint32_t bf32;					//--Working register;
//-------------------------------------------------------------------------------------------------
int8_t   idx,idb;				//--Index;	
uint8_t	 permitRX=0, permitTX=0;
uint8_t	 userRX=1,   userTX=1;
//-------------------------------------------------------------------------------------------------
uint8_t  speed=100;				//--100% -max, 0%-min;
uint8_t  time=0;				//--Working delay time(0-10);
};
//=================================================================================================
//						5.Data structure for working with the device via UART
//=================================================================================================	
struct RT_HW_STRUCT_UART_DEV{
//-------------------------------------------------------------------------------------------------
uint8_t  custom=0;				//--1.Setting option;
uint8_t  status=0;				//--2.Status device: =0 no init; =1 Master.MCU->Slave.device; =2 Slave;
uint8_t  link=0;				//--3.Completed transaction flag;
uint8_t  codeErr=0;				//--4.Code error;
//-------------------------------------------------------------------------------------------------
uint8_t  bus=255;				//--6.number UART
//-------------------------------------------------------------------------------------------------
uint8_t  bf8;					//--Working register;
//-------------------------------------------------------------------------------------------------
int8_t   idx,idb;				//--Index;	
//-------------------------------------------------------------------------------------------------
uint32_t speed=115200;			//--Speed;
};
//=================================================================================================
//						6.Data structure for working with the device via USB
//=================================================================================================	
/*
struct RT_HW_STRUCT_UART_USB{
uint32_t timeBegin; 
uint16_t dir=0;
uint8_t  cnt=0; uint8_t bf8=0;
//-------------------------------------------------------------------------------------------------
uint8_t  custom=0;				//--1.Setting option;
uint8_t  status=0;				//--2.Status device: =0 no init; =1 Master.MCU->Slave.device; =2 Slave;
uint8_t  link=0;				//--3.Completed transaction flag;
uint8_t  codeErr=0;				//--4.Code error;
//-------------------------------------------------------------------------------------------------
uint32_t speed=115200;			//--Speed;
};
*/

//=================================================================================================
//						6.Data structure for working with the LCD HD44780 с BUS via pins
//=================================================================================================
struct RT_HW_STRUCT_LCD_DEV{
uint8_t  custom=0;				//--1.Setting option;
uint8_t  status=0;				//--2.Status device: =0 no init; =1 Master.MCU->Slave.device; =2 Slave;
uint8_t  link=0;				//--3.Completed transaction flag;
uint8_t  codeErr=0;				//--4.Code error;
//-------------------------------------------------------------------------------------------------
uint8_t  pin[11];				//--RS,RW(E2),E1,D0-D7; 
uint8_t  permitE2=0;			//--Permit E2 (for LCD 40x4 =1);
//-------------------------------------------------------------------------------------------------
uint8_t  bf8;					//--Working register;
//-------------------------------------------------------------------------------------------------
int8_t   idx,idb;				//--Index;	
uint8_t  step;					//--Step for inner function;
uint32_t timeBegin;				//--Time for inner function;
//-------------------------------------------------------------------------------------------------
uint8_t  speed=100;				//--100% -max, 0%-min;
uint8_t  time=0;				//--Working delay time(0-10);
};
//=================================================================================================
//						7.Data structure for working with Link
//=================================================================================================
struct RT_HW_STRUCT_LINK_DEV{
//-------------------------------------------------------------------------------------------------
char     mi='x';				//--0.Mode interface;
uint8_t  custom=0;				//--1.Setting option;	
uint8_t  status=0;				//--2.Status device: =0 no init; =1 Master.MCU->Slave.device; =2 Slave;
uint8_t  link=0;				//--3.Completed transaction flag;
uint8_t  codeErr=0;				//--4.Code error;	
//--------------------------------------------------------------------------------------------------
uint8_t  dir=0;					//--5.Working  dir for direct();
//uint8_t  step;					//--6.Working step for add function;
uint8_t  ok;					//--7.1.Device ok;
uint8_t  fresh;					//--7.2.Fresh data;
//-------------------------------------------------------------------------------------------------
uint8_t  cnt,cntErr;			//--8.Counters;
//uint8_t  err:1,action:1;		//--9.Working flags;
//-------------------------------------------------------------------------------------------------
uint8_t  workDelay=0;			//--10.Working register; 
uint8_t  pointDelay;			//--11.Return point from a function;
uint16_t sizeDelay;				//--12.Size delay;	
uint32_t startDelay;		   	//--13.Working register;
//--------------------------------------------------------------------------------------------------
uint8_t  run=1;    				//--7.1.Flags to start reading;
};

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						2.Структуры для работы с консолью 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//=================================================================================================
//						2.1.Структура для работы с консолью (объект создается в RT_HW_BASE.h)
// dir-этапы настройки консоли; 
// ok-флаг готовности консоли; 
// head-флаг разрешения вывода заголовков (включается на один цикл при ok=1); 
// all-разрешение вывода после вывода заголовков;
// numUart: =0-8-аппаратные UART; =9-программный UART;  
//=================================================================================================
struct RT_HW_STRUCT_CONSOLE {
uint8_t dir=0; 
uint8_t run=0;
uint8_t ok=0; 
uint8_t head=0; 
uint8_t all=0; 
uint8_t numUart=0; 
uint8_t idx,idxOk; uint8_t bf8; 
uint8_t lenText,lenBuff;
uint8_t arr[8];
};
//=================================================================================================
//						2.2.Структуры для работы с сообщениями (объект создается в RT_HW_BASE.h)   
//=================================================================================================	
struct RT_HW_STRUCT_MESS {
uint8_t size=0;					//--Размер формируемого поля;
char 	agoAlig,    alig='L';  	//--Выравнивание в поле ('N',L','C','R');
char 	agoBlank,   blank=' ';	//--Код символа заполнителя;
char 	agoSignBit, signBit='1';//--Код набора символов  при выводе в битовой форме ('0','1'...'9');
char 	orderBit='F'; 			//--Порядок вывода битов при выводе в битовой форме;  
char 	modePin='T';   			//--Форматы вывода номера пина: D-десятичный, T-текстовый,   A-комбинированный;
char 	modeAdr='T';   			//--Форматы вывода адреса  i2c: D-десятичный, H-шестнадцат., A-комбинированный;
char    modeVar='B';			//--Формат переменной B,W,L,F,R,C,S;
char    mode='Z';				//--Формат вывода P,A,X,T,C,F,B,H,U,I,Z,z,0,1,2,3;
char    separator=',';			//--Разделитель. Используется при выводе массивов;
uint8_t qntBit=8;				//--Кол-во выводимых бит при выводе в битовой форме;
//--------------------------------------------------------------------------------------------------
uint8_t lenPin=3;	  			//--Длина поля для выводимого пина;
char    suff='~';				//--Суффикс;
uint8_t lenSuff,lenCR,hexShort=0;	//--Длина mess.str,длины заполнителей до и после mess.str;
uint8_t lenVar,lenBegin,lenEnd;	//--Длины заполнителей до и после mess.str;
uint8_t bf8;					//--Рабочий регистр;
uint8_t index;					//--Индекс для выбора символов RT_HW_READ_BYTE_PGM(RT_HW_ARR_BOOL_SIGN_x,index);
uint8_t idx;					//--Рабочий индекс для реализации циклов;
uint8_t adx=255;				//--Индекс для вывода массивов переменных;
uint8_t qnt;					//--Рабочее кол-во; 
String  str;			    	//--Формируемая строка;
};
