//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//								ОБЩАЯ ИДЕНТИФИКАЦИЯ ПЛАТ И АРХИТЕКТУР
// Используется  
//  Written by Khoi Hoang
//
//  Now even you use all these new 16 ISR-based timers,with their maximum interval practically unlimited (limited only by
//  unsigned long miliseconds), you just consume only one Hardware timer and avoid conflicting with other cores' tasks.
//  The accuracy is nearly perfect compared to software timers. The most important feature is they're ISR-based timers
//  Therefore, their executions are not blocked by bad-behaving functions / tasks.
//  This important feature is absolutely necessary for mission-critical tasks.
//
//  Based on SimpleTimer - A timer library for Arduino.
//  Author: mromani@ottotecnica.com
//  Copyright (c) 2010 OTTOTECNICA Italy
//
//  Based on BlynkTimer.h
//  Author: Volodymyr Shymanskyy
//
//  Built by Khoi Hoang https://github.com/khoih-prog/TimerInterrupt_Generic
//  Licensed under MIT license
//
//  Version: 1.13.0
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//												1.STM32
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//=================================================================================================
//											1.1.STM32
//=================================================================================================
#if !defined(RT_HW_BRD_CODE) && (defined(STM32F0) || defined(STM32F1)  ||  defined(STM32F2) || defined(STM32F3)  ||defined(STM32F4) || defined(STM32F7) || \
                                 defined(STM32L0) || defined(STM32L1)  ||  defined(STM32L4) || defined(STM32H7)  ||defined(STM32G0) || defined(STM32G4) || \
                                 defined(STM32WB) || defined(STM32MP1) || defined(STM32L5) )
#define RT_HW_BRD_CODE    30
#define RT_HW_BRD_TYPE    "STM32/ANON"
//-------------------------------------------------------------------------------------------------
#define RT_HW_TIMER_INTERRUPT_STM32  1
#endif
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//												2.RASPBERRY PI PICO
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if !defined(RT_HW_BRD_CODE) && (defined(ARDUINO_ARCH_RP2040) || defined(ARDUINO_RASPBERRY_PI_PICO) || defined(ARDUINO_ADAFRUIT_FEATHER_RP2040) || \
                                 defined(ARDUINO_GENERIC_RP2040)) \
						     && !defined(ARDUINO_ARCH_MBED)
#define RT_HW_BRD_CODE    30
#define RT_HW_BRD_TYPE    "Raspberry Pi Pico"
//-------------------------------------------------------------------------------------------------
#define RT_HW_TIMER_INTERRUPT_RP2040 1
#endif
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//												2.RASPBERRY PI PICO (MBED)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if !defined(RT_HW_BRD_CODE) && (defined(ARDUINO_NANO_RP2040_CONNECT) || defined(ARDUINO_RASPBERRY_PI_PICO) || defined(ARDUINO_ADAFRUIT_FEATHER_RP2040) || \
                                 defined(ARDUINO_GENERIC_RP2040)) \
						     && defined(ARDUINO_ARCH_MBED)
#define RT_HW_BRD_CODE    30
#define RT_HW_BRD_TYPE    "Rasoberry Pi Pico(MBED)"
//-------------------------------------------------------------------------------------------------
#define RT_HW_TIMER_INTERRUPT_RP2040_MBED  1
#endif
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//												2.ARCH ESP8266
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//=================================================================================================
//											ESP8266 ANON
//=================================================================================================
#if !defined(RT_HW_BRD_CODE) && (defined(ESP8266) || ESP8266 )
#define RT_HW_BRD_CODE    30
#define RT_HW_BRD_TYPE    "ESP8266 Generic/ANON"
//-------------------------------------------------------------------------------------------------
#define RT_HW_TIMER_INTERRUPT_ESP8266  1
#endif
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//												3.ARCH ESP32
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//=================================================================================================
//											ESP32 Dev Module/ANON
//=================================================================================================
#if !defined(RT_HW_BRD_CODE) && (defined(ESP32) || ESP32)
#define RT_HW_BRD_CODE    30
#define RT_HW_BRD_TYPE    "ESP32 Dev Module/ANON"
//-------------------------------------------------------------------------------------------------
#define RT_HW_TIMER_INTERRUPT_ESP32  1
#endif

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//												1.ARCH AVR
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//=================================================================================================
//											1.1.AVR MEGA2560
//=================================================================================================
#if !defined(RT_HW_BRD_CODE) && (defined(__AVR_ATmega2560__) || defined(__AVR_ATmega2561__) || defined(__AVR_ATmega1280__) || \
                                 defined(__AVR_ATmega1281__) || defined(__AVR_ATmega640__)  || defined(__AVR_ATmega641__))
#define RT_HW_BRD_CODE    1
#define RT_HW_BRD_TYPE    "Arduino AVR Mega2560"
//-------------------------------------------------------------------------------------------------
#define RT_HW_BRD_MEMORY "FLASH=256Kb,RAM=8Kb,EEPROM=4Kb;"			//--Параметры памяти;
#define RT_HW_BRD_FCPU     16 										//--Частота процессора;	
#define RT_HW_BRD_VCC      5000										//--Значение Vсс процессора;
#define RT_HW_BRD_MEGA2560_AVR										//--Идентификатор типа платы [variant.mega]
#define RT_HW_BRD_CORE_AVR											//--Идентификатор программной среды
//------Корректировка для PROGMEM------------------------------------------------------------------
#if defined(__AVR_ATmega2560__)							 
  #ifdef  PROGMEM
  #undef  PROGMEM
  #endif		
#define PROGMEM __attribute__(( section(".progmem.data") ))	
#endif
//-------------------------------------------------------------------------------------------------
#define RT_HW_TIMER_INTERRUPT_AVR  1
#endif
//=================================================================================================
//											1.2.AVR UNO,Nano,Pro, Pro, etc.
//=================================================================================================
#if !defined(RT_HW_BRD_CODE) && (defined(__AVR_ATmega644__) || defined(__AVR_ATmega644A__) || defined(__AVR_ATmega644P__) || defined(__AVR_ATmega644PA__)  || \
                                 defined(ARDUINO_AVR_UNO)   || defined(ARDUINO_AVR_NANO)   || defined(ARDUINO_AVR_MINI)   || defined(ARDUINO_AVR_ETHERNET) || \
                                 defined(ARDUINO_AVR_FIO)   || defined(ARDUINO_AVR_BT)     || defined(ARDUINO_AVR_LILYPAD)|| defined(ARDUINO_AVR_PRO)      || \
                                 defined(ARDUINO_AVR_NG)    || defined(ARDUINO_AVR_UNO_WIFI_DEV_ED)                       || defined(ARDUINO_AVR_DUEMILANOVE))
#define RT_HW_BRD_CODE    2
#define RT_HW_BRD_TYPE    "Arduino AVR UNO, Nano, Pro, etc."
//-------------------------------------------------------------------------------------------------
#define RT_HW_TIMER_INTERRUPT_AVR  1
#endif
//=================================================================================================
//											1.3.Adafruit AVR ATMega328(P)
//=================================================================================================
#if !defined(RT_HW_BRD_CODE) && (defined(ARDUINO_AVR_FEATHER328P) || defined(ARDUINO_AVR_METRO)           || defined(ARDUINO_AVR_PROTRINKET5) || \
                                 defined(ARDUINO_AVR_PROTRINKET3) || defined(ARDUINO_AVR_PROTRINKET5FTDI) || defined(ARDUINO_AVR_PROTRINKET3FTDI))
#define RT_HW_BRD_CODE    3
#define RT_HW_BRD_TYPE    "Adafruit AVR ATMega328(P)"
//-------------------------------------------------------------------------------------------------
#define RT_HW_TIMER_INTERRUPT_AVR  1
#endif
//=================================================================================================
//											1.4.AVR ATMEGA32U4
//=================================================================================================
#if !defined(RT_HW_BRD_CODE) && (defined(ARDUINO_AVR_LEONARDO) || defined(ARDUINO_AVR_LEONARDO_ETH) || defined(ARDUINO_AVR_YUN) || \
                                 defined(ARDUINO_AVR_MICRO)    || defined(ARDUINO_AVR_ESPLORA)      || defined(ARDUINO_AVR_LILYPAD_USB)  || \
								 defined(ARDUINO_AVR_ROBOT_CONTROL) || defined(ARDUINO_AVR_ROBOT_MOTOR)   || defined(ARDUINO_AVR_CIRCUITPLAY) || \
								 defined(ARDUINO_AVR_YUNMINI)       || defined(ARDUINO_AVR_INDUSTRIAL101) || defined(ARDUINO_AVR_LININO_ONE))
#define RT_HW_BRD_CODE    4
#define RT_HW_BRD_TYPE    "Arduino AVR ATMega32U4"
//-------------------------------------------------------------------------------------------------
#define RT_HW_TIMER_INTERRUPT_AVR  1
#endif
//=================================================================================================
//											1.5.Adafruit AVR ATMega32U4
//=================================================================================================
#if !defined(RT_HW_BRD_CODE) && (defined(ARDUINO_AVR_FLORA8 )          || defined(ARDUINO_AVR_FEATHER32U4)      || defined(ARDUINO_AVR_CIRCUITPLAY) || \
                                 defined(ARDUINO_AVR_ITSYBITSY32U4_5V) || defined(ARDUINO_AVR_ITSYBITSY32U4_3V) || defined(ARDUINO_AVR_BLUEFRUITMICRO) || \
								 defined(ARDUINO_AVR_ADAFRUIT32U4))
#define RT_HW_BRD_CODE    5
#define RT_HW_BRD_TYPE    "Adafruit AVR ATMega32U4"
//-------------------------------------------------------------------------------------------------
#define RT_HW_TIMER_INTERRUPT_AVR  1
#endif
//=================================================================================================
//											1.6.Generic or Sparkfun AVR ATMega32U4
//=================================================================================================
#if !defined(RT_HW_BRD_CODE) && (defined(__AVR_ATmega32U4__) || defined(ARDUINO_AVR_MAKEYMAKEY ) || defined(ARDUINO_AVR_PROMICRO) || \
                                 defined(ARDUINO_AVR_FIOV3)  || defined(ARDUINO_AVR_QDUINOMINI)  || defined(ARDUINO_AVR_LILYPAD_ARDUINO_USB_PLUS_BOARD )) \
							 && !defined(TEENSYDUINO)
#define RT_HW_BRD_CODE    6
#define RT_HW_BRD_TYPE    "Generic or Sparkfun AVR ATMega32U4"
//-------------------------------------------------------------------------------------------------
#define RT_HW_TIMER_INTERRUPT_AVR  1
#endif
//=================================================================================================
//											1.7.Generic or Sparkfun AVR ATMega328P
//=================================================================================================
#if !defined(RT_HW_BRD_CODE) && (defined(__AVR_ATmega328P__) || defined(ARDUINO_AVR_DIGITAL_SANDBOX ) || defined(ARDUINO_REDBOT) || \
                                 defined(ARDUINO_AVR_SERIAL_7_SEGMENT))
#define RT_HW_BRD_CODE    7
#define RT_HW_BRD_TYPE    "Generic or Sparkfun AVR ATMega328P"
//-------------------------------------------------------------------------------------------------
#define RT_HW_TIMER_INTERRUPT_AVR  1
#endif
//=================================================================================================
//											1.8.Generic or Sparkfun AVR ATMega128RFA1
//=================================================================================================
#if !defined(RT_HW_BRD_CODE) && ( defined(__AVR_ATmega128RFA1__) || defined(ARDUINO_ATMEGA128RFA1_DEV_BOARD) )
#define RT_HW_BRD_CODE    7
#define RT_HW_BRD_TYPE    "Generic or Sparkfun AVR ATMega128RFA1"
//-------------------------------------------------------------------------------------------------
#define RT_HW_TIMER_INTERRUPT_AVR  1
#endif
//=================================================================================================
//											1.9.AVR ANON
//=================================================================================================
#if !defined(RT_HW_BRD_CODE) && ( defined(__AVR__) 
#error These AVR boards are not supported! Please check your Tools->Board setting.
#define RT_HW_BRD_CODE    9
#define RT_HW_BRD_TYPE    "AVR ANON"
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//												2.ARCH SAMD
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//=================================================================================================
//											2.1.SAMD
//=================================================================================================
#if !defined(RT_HW_BRD_CODE) && (defined(ARDUINO_SAMD_ZERO)         || defined(ARDUINO_SAMD_MKR1000)    || defined(ARDUINO_SAMD_MKRWIFI1010) || \
                                 defined(ARDUINO_SAMD_NANO_33_IOT)  || defined(ARDUINO_SAMD_MKRFox1200) || defined(ARDUINO_SAMD_MKRWAN1300)  || \
								 defined(ARDUINO_SAMD_MKRWAN1310)   || defined(ARDUINO_SAMD_MKRGSM1400) || defined(ARDUINO_SAMD_MKRNB1500)   || \
								 defined(ARDUINO_SAMD_MKRVIDOR4000) || defined(ARDUINO_SAMD_CIRCUITPLAYGROUND_EXPRESS)                       || \
								 defined(__SAMD21E18A__)            || defined(__SAMD21G18A__)                                               || \
								 defined(__SAMD51__)                || defined(__SAMD51J20A__)          || defined(__SAMD51J19A__)           || \
								 defined(__SAMD51G19A__)            || defined(__SAMD51P19A__))
#define RT_HW_BRD_CODE    10
#define RT_HW_BRD_TYPE    "Generic or Sparkfun AVR ATMega128RFA1"
//-------------------------------------------------------------------------------------------------
#define RT_HW_TIMER_INTERRUPT_SAMD  1
#endif


//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//											3.ARCH NRF52
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//=================================================================================================
//											AVR UNO,Nano,Pro, Pro, etc.
//=================================================================================================
#if !defined(RT_HW_BRD_CODE) && (defined(NRF52832_FEATHER)  || defined(NRF52_SERIES)           || defined(ARDUINO_NRF52_ADAFRUIT) || \
                                 defined(NRF52840_FEATHER)  || defined(NRF52840_FEATHER_SENSE) || defined(NRF52840_ITSYBITSY)     || \
								 defined(NRF52840_CLUE)     || defined(NRF52840_METRO)         || defined(NRF52840_CIRCUITPLAY)   || \
								 defined(NRF52840_PCA10056) || defined(PARTICLE_XENON)                                            || \
                                 defined(MDBT50Q_RX)        || defined(NINA_B302_ublox)        || defined(NINA_B112_ublox))
#define RT_HW_BRD_CODE    10
#define RT_HW_BRD_TYPE    "NRF52"
//-------------------------------------------------------------------------------------------------
#define RT_HW_TIMER_INTERRUPT_NRF52  1
#endif

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//											3.ARCH SAM
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//=================================================================================================
//											3.1.SAM DUE
//=================================================================================================
#if !defined(RT_HW_BRD_CODE) && ( defined(ARDUINO_SAM_DUE) || defined(__SAM3X8E__) )
#define RT_HW_BRD_CODE    10
#define RT_HW_BRD_TYPE    "NRF52"
//-------------------------------------------------------------------------------------------------
#define RT_HW_TIMER_INTERRUPT_NRF52  1
#endif

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//											4.ARCH TEENSY
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//=================================================================================================
//											4.1.TEENSY
//=================================================================================================
#if !defined(RT_HW_BRD_CODE) && (defined(CORE_TEENSY)  || defined(__IMXRT1062__) || defined(__MK66FX1M0__) || defined(__MK64FX512__) || \
                                 defined(__MKL26Z64__) || defined(__MK20DX256__) || defined(__MK20DX128__))
#define RT_HW_BRD_CODE    10
#define RT_HW_BRD_TYPE    "NRF52"
//-------------------------------------------------------------------------------------------------
#define RT_HW_TIMER_INTERRUPT_NRF52  1
#endif

//=================================================================================================
//											AVR UNO,Nano,Pro, Pro, etc.
//=================================================================================================
#if !defined(RT_HW_BRD_CODE) 
#error Unsupported Board! Please check your Tools->Board setting.
#endif

////////////////////////////////////////////////////


////////////////////////////////////////////////////
