//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
//            					ADS1115 (ADC)
//
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//  ecoins (ecoins@mail.ru) 
//  21.05.2023: Begin version
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#ifndef RT_HW_ADS1115_h
#define RT_HW_ADS1115_h
#define RT_HW_ADS1115_VER 		10		//--Library version number;
#include "RT_HW_BASE.h"					//--Connecting the base library;
//-------------------------------------------------------------------------------------------------
//									1.1.POINTER REGISTER
//-------------------------------------------------------------------------------------------------
#define RT_HW_ADS1115_POINTER_MASK        (0x03)
#define RT_HW_ADS1115_POINTER_CONVERT     (0x00)
#define RT_HW_ADS1115_POINTER_CONFIG      (0x01)
#define RT_HW_ADS1115_POINTER_LOWTHRESH   (0x02)
#define RT_HW_ADS1115_POINTER_HITHRESH    (0x03)
//-------------------------------------------------------------------------------------------------
//									1.2.PARAMETERE FOR CONFIG REGISTER
//-------------------------------------------------------------------------------------------------
#define RT_HW_ADS1115_OS_MASK      	(0x8000)
#define RT_HW_ADS1115_OS_SINGLE    	(0x8000)  // Write: Set to start a single-conversion
#define RT_HW_ADS1115_OS_BUSY      	(0x0000)  // Read: Bit = 0 when conversion is in progress
#define RT_HW_ADS1115_OS_NOTBUSY   	(0x8000)  // Read: Bit = 1 when device is not performing a conversion
//--------------------------------------------------------------------------------------------------
#define RT_HW_ADS1115_MUX_MASK     	(0x7000)
#define RT_HW_ADS1115_MUX_A0 		(0x4000)  //--single input A0;
#define RT_HW_ADS1115_MUX_A1 		(0x5000)  //--single input A1;
#define RT_HW_ADS1115_MUX_A2 		(0x6000)  //--single input A2;
#define RT_HW_ADS1115_MUX_A3 		(0x7000)  //--single input A3;
#define RT_HW_ADS1115_MUX_A01 		(0x0000)  //--differential input P=0, N=A1;
#define RT_HW_ADS1115_MUX_A03 		(0x1000)  //--differential input P=0, N=A3;
#define RT_HW_ADS1115_MUX_A13 		(0x2000)  //--differential input P=1, N=A3;
#define RT_HW_ADS1115_MUX_A23 		(0x3000)  //--differential input P=2, N=A3;
//-------------------------------------------------------------------------------------------------
#define RT_HW_ADS1115_PGA_MASK     (0x0E00)
#define RT_HW_ADS1115_PGA_6_144V   (0x0000)  //--scale=0-> +/-6.144V range=2/3;
#define RT_HW_ADS1115_PGA_4_096V   (0x0200)  //--scale=1-> +/-4.096V range=1;
#define RT_HW_ADS1115_PGA_2_048V   (0x0400)  //--scale=2-> +/-2.048V range=2;
#define RT_HW_ADS1115_PGA_1_024V   (0x0600)  //--scale=3-> +/-1.024V range=4;
#define RT_HW_ADS1115_PGA_0_512V   (0x0800)  //--scale=4-> +/-0.512V range=8;
#define RT_HW_ADS1115_PGA_0_256V   (0x0A00)  //--scale=5-> +/-0.256V range=16;
//-------------------------------------------------------------------------------------------------
#define RT_HW_ADS1115_MODE_MASK    (0x0100)
#define RT_HW_ADS1115_MODE_CONTIN  (0x0000)  // Continuous conversion mode
#define RT_HW_ADS1115_MODE_SINGLE  (0x0100)  // Power-down single-shot mode (default)
//-------------------------------------------------------------------------------------------------
#define RT_HW_ADS1115_DR_MASK      (0x00E0)  
#define RT_HW_ADS1115_DR_128SPS    (0x0000)  // 128 samples per second
#define RT_HW_ADS1115_DR_250SPS    (0x0020)  // 250 samples per second
#define RT_HW_ADS1115_DR_490SPS    (0x0040)  // 490 samples per second
#define RT_HW_ADS1115_DR_920SPS    (0x0060)  // 920 samples per second
#define RT_HW_ADS1115_DR_1600SPS   (0x0080)  // 1600 samples per second (default)
#define RT_HW_ADS1115_DR_2400SPS   (0x00A0)  // 2400 samples per second
#define RT_HW_ADS1115_DR_3300SPS   (0x00C0)  // 3300 samples per second
//-------------------------------------------------------------------------------------------------
#define RT_HW_ADS1115_CMODE_MASK   (0x0010)
#define RT_HW_ADS1115_CMODE_TRAD   (0x0000)  // Traditional comparator with hysteresis (default)
#define RT_HW_ADS1115_CMODE_WINDOW (0x0010)  // Window comparator
//-------------------------------------------------------------------------------------------------
#define RT_HW_ADS1115_CPOL_MASK    (0x0008)
#define RT_HW_ADS1115_CPOL_ACTVLOW (0x0000)  // ALERT/RDY pin is low when active (default)
#define RT_HW_ADS1115_CPOL_ACTVHI  (0x0008)  // ALERT/RDY pin is high when active
//-------------------------------------------------------------------------------------------------
#define RT_HW_ADS1115_CLAT_MASK    (0x0004)  // Determines if ALERT/RDY pin latches once asserted
#define RT_HW_ADS1115_CLAT_NONLAT  (0x0000)  // Non-latching comparator (default)
#define RT_HW_ADS1115_CLAT_LATCH   (0x0004)  // Latching comparator
//-------------------------------------------------------------------------------------------------
#define RT_HW_ADS1115_CQUE_MASK    (0x0003)
#define RT_HW_ADS1115_CQUE_1CONV   (0x0000)  // Assert ALERT/RDY after one conversions
#define RT_HW_ADS1115_CQUE_2CONV   (0x0001)  // Assert ALERT/RDY after two conversions
#define RT_HW_ADS1115_CQUE_4CONV   (0x0002)  // Assert ALERT/RDY after four conversions
#define RT_HW_ADS1115_CQUE_NONE    (0x0003)  // Disable the comparator and put ALERT/RDY in high state (default)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
struct RT_HW_ADS1115_DEV{
RT_HW_STRUCT_I2C_DEV dvI;
//-------------------------------------------------------------------------------------------------
char     mi='I';				//--0.Mode interface;
uint8_t  custom=0;				//--1.Setting option;	
uint8_t  status=0;				//--2.Status device: =0 no init; =1 Master.MCU->Slave.device; =2 Slave;
uint8_t  link=0;				//--3.Completed transaction flag;
uint8_t  codeErr=0;				//--4.Code error;
//--------------------------------------------------------------------------------------------------;
uint8_t  dir;					//--5.Working  dir for direct();
uint8_t  step;					//--6.Working step for add function;
//-------------------------------------------------------------------------------------------------
uint8_t  cnt,cntErr;			//--8.Counters;
uint8_t  err:1,action:1;		//--9.Working flags;
//-------------------------------------------------------------------------------------------------
uint8_t  workDelay=0;			//--10.Working register; 
uint8_t  pointDelay;			//--11.Return point from a function;
uint16_t sizeDelay;				//--12.Size delay;	
uint32_t startDelay;		    //--13.Working register;
//-------------------------------------------------------------------------------------------------
uint8_t  run;					//--14.Command run;
uint8_t  ok;					//--15.Device ok;
uint8_t  fresh;					//--16.Fresh data;
//-------------------------------------------------------------------------------------------------
uint8_t  timeMeter=8;			//--17.Time meter for ADS1115;
uint8_t  scale=0;				//--18.Code range(V)->0:6.144, 1:4.096, 2:2.048, 3:1.024, 4:0.512, 5:0.256;
uint16_t modePGA=0;				//--19.ADS1115_PGA;
uint8_t  permitA0=1, permitA1=1, permitA2=1, permitA3=1,
         permitA01=0,permitA03=0,permitA13=0,permitA23=0;
//-------------------------------------------------------------------------------------------------
uint16_t baseConfig=			//--19.Config meter;
			RT_HW_ADS1115_CQUE_NONE    | //--Disable the comparator (default val)
            RT_HW_ADS1115_CLAT_NONLAT  | //--Non-latching (default val)
            RT_HW_ADS1115_CPOL_ACTVLOW | //--Alert/Rdy active low   (default val)
            RT_HW_ADS1115_CMODE_TRAD   | //--Traditional comparator (default val)
            RT_HW_ADS1115_DR_1600SPS   | //--1600 samples per second (default)
            RT_HW_ADS1115_MODE_SINGLE;   //--Single-shot mode (default);
uint16_t config;				//--20.Work config;
int16_t  vMeter;				//--21.Meter value;
int16_t  vA0,vA1,vA2,vA3,vA01,vA03,vA13,vA23;		    
float    vTemp;
//-------------------------------------------------------------------------------------------------
uint8_t  bf8;					//--Buffer for reading byte;
uint8_t  arr[3];              	//--Buffer for temporary data storage
uint8_t  idx;					//--Indexs;
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//=================================================================================================
//                            		CLASS ADS1115
//=================================================================================================
class RT_HW_ADS1115{
public:
//=================================================================================================
//									1.Device management
//=================================================================================================
void direct(RT_HW_ADS1115_DEV &id, uint8_t &run){
//-------------------------------------------------------------------------------------------------
if(run>0){id.run=1; run=5;}; 
//-------------------------------------------------------------------------------------------------
//									1.0.Setting parameters
//-------------------------------------------------------------------------------------------------
if(id.dir==0){	
getParamDevice(id);
id.step=id.workDelay=0; id.ok=0; id.fresh=1; 
id.vA0=id.vA1=id.vA2=id.vA3=id.vA01=id.vA03=id.vA13=id.vA23=0;
if(id.custom==0){return;} 								id.dir=10;} 
//-------------------------------------------------------------------------------------------------
//									1.10.Calling the init function
//-------------------------------------------------------------------------------------------------
if(id.dir==10){
if(!id.run){return;}
init(id);  
if(id.err){		id.pointDelay=0;	id.sizeDelay=1000; 	id.dir=200;  return;} 
if(!id.action){	id.step=0; 								id.dir=20;}}
//-------------------------------------------------------------------------------------------------
//									1.20.Waiting to run
//-------------------------------------------------------------------------------------------------
if(id.dir==20){
if(!id.run){return;} id.run=0; 							id.dir=30;}
//-------------------------------------------------------------------------------------------------
//									1.30.Calling the process function A0
//-------------------------------------------------------------------------------------------------
if(id.dir==30){if(id.permitA0){id.dir=31;}   else{id.dir=40;}}
//-------------------------------------------------------------------------------------------------
if(id.dir==31){
process(id,0);  
if(id.err){		id.pointDelay=0;	id.sizeDelay=200;	id.dir=200; return;} 
if(!id.action){	id.step=0; 			id.vA0=id.vMeter;	id.dir=40;  return;}}	
//-------------------------------------------------------------------------------------------------
//									1.40.Calling the process function A1
//-------------------------------------------------------------------------------------------------
if(id.dir==40){if(id.permitA1){id.dir=41;}   else{id.dir=50;}}
//-------------------------------------------------------------------------------------------------
if(id.dir==41){
process(id,1);  
if(id.err){		id.pointDelay=0;	id.sizeDelay=200;	id.dir=200; return;} 
if(!id.action){	id.step=0; 			id.vA1=id.vMeter;	id.dir=50;  return;}}
//-------------------------------------------------------------------------------------------------
//									1.50.Calling the process function A2
//-------------------------------------------------------------------------------------------------
if(id.dir==50){if(id.permitA2){id.dir=51;}   else{id.dir=60;}}
//-------------------------------------------------------------------------------------------------
if(id.dir==51){
process(id,2);  
if(id.err){		id.pointDelay=0;	id.sizeDelay=200;	id.dir=200; return;} 
if(!id.action){	id.step=0; 			id.vA2=id.vMeter;	id.dir=60;  return;}}
//-------------------------------------------------------------------------------------------------
//									1.60.Calling the process function A3
//-------------------------------------------------------------------------------------------------
if(id.dir==60){if(id.permitA3){id.dir=61;}   else{id.dir=70;}}
//-------------------------------------------------------------------------------------------------
if(id.dir==61){
process(id,3);  
if(id.err){		id.pointDelay=0;	id.sizeDelay=200;	id.dir=200; return;} 
if(!id.action){	id.step=0; 			id.vA3=id.vMeter;	id.dir=70;  return;}}
//-------------------------------------------------------------------------------------------------
//									1.70.Calling the process function A01
//-------------------------------------------------------------------------------------------------
if(id.dir==70){if(id.permitA01){id.dir=71;}   else{id.dir=80;}}
//-------------------------------------------------------------------------------------------------
if(id.dir==71){
process(id,4);  
if(id.err){		id.pointDelay=0;	id.sizeDelay=200;	id.dir=200; return;} 
if(!id.action){	id.step=0; 			id.vA01=id.vMeter;	id.dir=80;  return;}}
//-------------------------------------------------------------------------------------------------
//									1.80.Calling the process function A03
//-------------------------------------------------------------------------------------------------
if(id.dir==80){if(id.permitA03){id.dir=81;}   else{id.dir=90;}}
//-------------------------------------------------------------------------------------------------
if(id.dir==81){
process(id,5);  
if(id.err){		id.pointDelay=0;	id.sizeDelay=200;	id.dir=200; return;} 
if(!id.action){	id.step=0;  		id.vA03=id.vMeter;	id.dir=90;  return;}}
//-------------------------------------------------------------------------------------------------
//									1.90.Calling the process function A03
//-------------------------------------------------------------------------------------------------
if(id.dir==90){if(id.permitA13){id.dir=91;}   else{id.dir=100;}}
//-------------------------------------------------------------------------------------------------
if(id.dir==91){
process(id,6);  
if(id.err){		id.pointDelay=0;	id.sizeDelay=200;	id.dir=200; return;} 
if(!id.action){	id.step=0;  		id.vA13=id.vMeter;	id.dir=100; return;}}
//-------------------------------------------------------------------------------------------------
//									1.100.Calling the process function A23
//-------------------------------------------------------------------------------------------------
if(id.dir==100){if(id.permitA23){id.dir=101;} else{id.dir=150;}}
//-------------------------------------------------------------------------------------------------
if(id.dir==101){
process(id,6);  
if(id.err){		id.pointDelay=0;	id.sizeDelay=200;	id.dir=200; return;} 
if(!id.action){	id.step=0;  		id.vA23=id.vMeter;	id.dir=150; return;}}
//-------------------------------------------------------------------------------------------------
//									1.90.End device management 
//-------------------------------------------------------------------------------------------------
if(id.dir==150){id.ok=1; id.fresh=1;
				id.pointDelay=20;	id.sizeDelay=10;  	id.dir=200; return;}
//-------------------------------------------------------------------------------------------------
//									1.200.Dynamic Delay
//-------------------------------------------------------------------------------------------------
if(id.dir==200){
if(!RT_HW_Base.timeDelay(id.startDelay,id.workDelay,id.sizeDelay)){ return;} id.dir=id.pointDelay;}	
//-------------------------------------------------------------------------------------------------
};	//====END direct()=============================================================================

//=================================================================================================
//									2.Device initialization
//=================================================================================================
void init(RT_HW_ADS1115_DEV &id){
//-------------------------------------------------------------------------------------------------
//									2.0.Setting parameters with continue after 50 m
//-------------------------------------------------------------------------------------------------
if(id.step==0){
id.cnt=id.cntErr=id.err=0; id.action=1; 
id.pointDelay=10; id.sizeDelay=50; id.step=200; return;}
//-------------------------------------------------------------------------------------------------
//									2.10.Device initialization	
//-------------------------------------------------------------------------------------------------
if(id.step==10) {	
xxxInitDevice(id);	if(!id.link)	{return;}
if(id.status!=1){id.err=1; id.step=0;return;} 
id.cnt=id.cntErr=0; 
if(id.mi=='I')  {id.step=20;} else {id.step=30;}}	
//-------------------------------------------------------------------------------------------------
//									2.20.Address search				
//-------------------------------------------------------------------------------------------------
if(id.step==20) {
xxxFindAdr(id);   	if(!id.link){return;}	
//-------------------------------------------------------------------------------------------------
if(id.codeErr){
id.cnt=0; id.cntErr++;
if(id.cntErr<=3){id.pointDelay=id.step;	id.sizeDelay=100+(250*id.cntErr); id.step=200; return;}	
if(id.cntErr==3){id.pointDelay=id.step; id.sizeDelay=2000; 				  id.step=200; return;}
				 id.codeErr=id.step;    id.err=1; 						  id.step=0;   return;}
//-------------------------------------------------------------------------------------------------
id.cnt++; id.cntErr=0;	
if(id.cnt<5){   id.pointDelay=id.step; 	id.sizeDelay=50;	id.step=200; return;}				
				id.pointDelay=30;	  	id.sizeDelay=10;	id.step=200; return;}
//-------------------------------------------------------------------------------------------------
//									2.30.Preparing parameters
//-------------------------------------------------------------------------------------------------
if(id.step==30){
id.modePGA=RT_HW_ADS1115_PGA_6_144V;
if(id.scale==0) {id.modePGA=RT_HW_ADS1115_PGA_6_144V;}	 //--PGA-> +/-6.144V range = Gain 2/3
if(id.scale==1) {id.modePGA=RT_HW_ADS1115_PGA_4_096V;}   //--PGA-> +/-4.096V range = Gain 1
if(id.scale==2) {id.modePGA=RT_HW_ADS1115_PGA_2_048V;}   //--PGA-> +/-2.048V range = Gain 2 (default)
if(id.scale==4) {id.modePGA=RT_HW_ADS1115_PGA_1_024V;}   //--PGA-> +/-1.024V range = Gain 4
if(id.scale==8) {id.modePGA=RT_HW_ADS1115_PGA_0_512V;}   //--PGA-> +/-0.512V range = Gain 8
if(id.scale==16){id.modePGA=RT_HW_ADS1115_PGA_0_256V;}   //--PGA-> +/-0.256V range = Gain 16
id.step=90;}
//-------------------------------------------------------------------------------------------------
//									2.90.End device init
//-------------------------------------------------------------------------------------------------
if(id.step==90){id.err=id.action=id.step=0; return;}
//-------------------------------------------------------------------------------------------------
//									2.200.Dynamic Delay
//-------------------------------------------------------------------------------------------------
if(id.step==200){if(!RT_HW_Base.timeDelay(id.startDelay,id.workDelay,id.sizeDelay)){return;} id.step=id.pointDelay;}
};	//====END init()===============================================================================

//=================================================================================================
//									3.Device process
//=================================================================================================
void process(RT_HW_ADS1115_DEV &id, uint8_t num){
//-------------------------------------------------------------------------------------------------
//									3.0.Setting parameters with continue after 50 ms
//-------------------------------------------------------------------------------------------------
if(id.step==0){
if(num>7){id.err=1; id.codeErr=70; return;}
id.cnt=id.cntErr=id.err=0; id.action=1; 
id.pointDelay=10; id.sizeDelay=50; id.step=200;  return;}
//-------------------------------------------------------------------------------------------------
//									3.10.Start measurement	
//-------------------------------------------------------------------------------------------------
if(id.step==10){ 
id.config=id.baseConfig | RT_HW_ADS1115_OS_SINGLE | id.modePGA;
if(num==0){id.config=id.config | RT_HW_ADS1115_MUX_A0;}		//--single input A0;
if(num==1){id.config=id.config | RT_HW_ADS1115_MUX_A1;}		//--single input A1;
if(num==2){id.config=id.config | RT_HW_ADS1115_MUX_A2;}		//--single input A2;
if(num==3){id.config=id.config | RT_HW_ADS1115_MUX_A3;}		//--single input A3;
if(num==4){id.config=id.config | RT_HW_ADS1115_MUX_A01;}	//--differential input P=0, N=A1;
if(num==5){id.config=id.config | RT_HW_ADS1115_MUX_A03;}	//--differential input P=0, N=A3;
if(num==6){id.config=id.config | RT_HW_ADS1115_MUX_A13;}	//--differential input P=1, N=A3;
if(num==7){id.config=id.config | RT_HW_ADS1115_MUX_A23;}	//--differential input P=2, N=A3;
//-------------------------------------------------------------------------------------------------
id.arr[0]=RT_HW_ADS1115_POINTER_CONFIG;
id.arr[1]=(id.config>>8)&0xFF;
id.arr[2]=(id.config)   &0xFF;
id.step=11;}
//-------------------------------------------------------------------------------------------------
if(id.step==11){
xxxWriteArr(id,3);		if(checkTransaction(id)){return;}	//--if link ok:: pointDelay=step; step=200; After 3fd error: err=1; step=0; return;
id.sizeDelay=id.timeMeter;  id.pointDelay=40;   return;}	 		
//-------------------------------------------------------------------------------------------------
//									3.40.Getting measurement results
//-------------------------------------------------------------------------------------------------
if(id.step==40){
xxxREADArr(id,RT_HW_ADS1115_POINTER_CONVERT,2); if(checkTransaction(id)){return;} 
id.step=50; 		 							 return;}	
//-------------------------------------------------------------------------------------------------
//									3.50.Result Calculations
//-------------------------------------------------------------------------------------------------
if(id.step==50){
	id.vMeter=(id.arr[0] << 8) | id.arr[1]; 
id.step=90;}
//-------------------------------------------------------------------------------------------------
//									3.90.End device process
//-------------------------------------------------------------------------------------------------
if(id.step==90){id.err=id.action=id.step=0; return;}
//-------------------------------------------------------------------------------------------------
//									3.200.Dynamic Delay
//-------------------------------------------------------------------------------------------------
if(id.step==200){if(!RT_HW_Base.timeDelay(id.startDelay,id.workDelay,id.sizeDelay)){return;} id.step=id.pointDelay;}
};	//====END process()============================================================================


//=================================================================================================
float getVar_V(RT_HW_ADS1115_DEV &id, int16_t adc){
if(id.scale==0){return adc*6.144f/32768;}
if(id.scale==1){return adc*4.096f/32768;}
if(id.scale==2){return adc*2.048f/32768;}
if(id.scale==3){return adc*1.024f/32768;}
if(id.scale==4){return adc*0.512f/32768;}
if(id.scale==5){return adc*0.256f/32768;}
return 0.0f;}
//=================================================================================================
float getVar_mV(RT_HW_ADS1115_DEV &id, int16_t adc){
if(id.scale==0){return adc*6144.0f/32768;}
if(id.scale==1){return adc*4096.0f/32768;}
if(id.scale==2){return adc*2048.0f/32768;}
if(id.scale==3){return adc*1024.0f/32768;}
if(id.scale==4){return adc* 512.0f/32768;}
if(id.scale==5){return adc* 256.0f/32768;}
return 0.0f;}
//=================================================================================================
int16_t getVar_sys(RT_HW_ADS1115_DEV &id, int16_t adc){
if(id.scale==0){return adc*6144/32768;}
if(id.scale==1){return adc*4096/32768;}
if(id.scale==2){return adc*2048/32768;}
if(id.scale==3){return adc*1024/32768;}
if(id.scale==4){return adc* 512/32768;}
if(id.scale==5){return adc* 256/32768;}
return 0;}



//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
//									7.Device Link Functions.
//
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//=================================================================================================
//									7.0.Function error check.
//=================================================================================================
uint8_t checkTransaction(RT_HW_ADS1115_DEV &id){
if(!id.link) {return 1;}
id.pointDelay=id.step; id.step=200;
if(id.codeErr!=0){id.sizeDelay=40+(10*id.cntErr); id.cntErr++; 
                  if(id.cntErr>3){id.codeErr=id.pointDelay; id.err=1; id.step=0;} 
				  return 1;}
id.cntErr=0; return 0;};
//=================================================================================================
//									7.1.Getting Interface Device Parameters
//=================================================================================================
void getParamDevice(RT_HW_ADS1115_DEV &id){
if(id.mi=='I'){id.custom=id.dvI.custom; id.codeErr=id.dvI.codeErr; id.status=id.dvI.status; id.link=id.dvI.link; id.bf8=id.dvI.bf8; return;}
               id.custom=0;             id.codeErr=0;              id.status=0;             id.link=1;           id.bf8=0;          return;}
//=================================================================================================
//									7.3.Init Device.
//=================================================================================================
void xxxInitDevice(RT_HW_ADS1115_DEV &id){
if(id.mi=='I'){RT_HW_Base.i2cInitDevice(id.dvI); 				getParamDevice(id); return;}		
getParamDevice(id);};
//=================================================================================================
//									7.2.Find address Device.
//=================================================================================================
void xxxFindAdr(RT_HW_ADS1115_DEV &id){
if(id.mi=='I'){RT_HW_Base.i2cFindAdr(id.dvI); 					getParamDevice(id); return;}	
getParamDevice(id);};
//=================================================================================================
//									7.4.Wtite byte to register.
//=================================================================================================
void xxxWriteArr(RT_HW_ADS1115_DEV &id, uint8_t qnt){	
if(id.mi=='I'){RT_HW_Base.i2cWriteArr(id.dvI,id.arr,qnt); 	 	getParamDevice(id); return;}
getParamDevice(id);};
//=================================================================================================
//									7.5.Read byte from register
//=================================================================================================
//void xxxREAD(RT_HW_AHTxx_DEV &id, uint8_t reg){
//if(id.mi=='I'){RT_HW_Base.i2cREAD(id.dvI,reg); 			 		getParamDevice(id); return;}		
//getParamDevice(id);};
//=================================================================================================
//									7.6.Read bytes from register
//=================================================================================================
void xxxREADArr(RT_HW_ADS1115_DEV &id, uint8_t reg, uint8_t qnt){	
//-------------------------------------------------------------------------------------------------
if(id.mi=='I'){RT_HW_Base.i2cREADArr(id.dvI,reg,id.arr,qnt);	getParamDevice(id); return;}
getParamDevice(id);};
//=================================================================================================
//									7.11.Get bytes.
//=================================================================================================
void xxxReadArr(RT_HW_ADS1115_DEV &id, uint8_t qnt){	
if(id.mi=='I'){RT_HW_Base.i2cReadArr(id.dvI,id.arr,qnt); 		getParamDevice(id); return;};
getParamDevice(id);};
//=================================================================================================
};	//++++END class RT_HW_RT_HW_ADS1115====================================================================
extern RT_HW_ADS1115 	RT_HW_ads1115; 						//--Create an object RT_HW_ADS1115;
#endif
//=================================================================================================
